/**
 * @file 
 * @brief See Ochannel.h
 * @author Florent Robinet - <a href="mailto:florent.robinet@ijclab.in2p3.fr">florent.robinet@ijclab.in2p3.fr</a>
 */
#include "Ochannel.h"

////////////////////////////////////////////////////////////////////////////////////
Ochannel::Ochannel(const unsigned int aSize, const string aStreamName, const int unsigned aVerbose):
  TriggerBuffer(aSize, aStreamName, aVerbose){
////////////////////////////////////////////////////////////////////////////////////
  outdir = ".";
  chunk_trig_n = 0;
  proc_segments = new Segments();
  ResetHistory();
}

////////////////////////////////////////////////////////////////////////////////////
Ochannel::~Ochannel(void){
////////////////////////////////////////////////////////////////////////////////////
  ResetHistory();
  delete proc_segments;
}

////////////////////////////////////////////////////////////////////////////////////
void Ochannel::ResetHistory(void){
////////////////////////////////////////////////////////////////////////////////////
  chunk_map_snrmax = 0.0;
  chunk_load.clear();
  chunk_condition.clear();
  chunk_project.clear();
  chunk_write.clear();
  chunk_write_tfile.clear();
  proc_segments->Reset();
}

////////////////////////////////////////////////////////////////////////////////////
void Ochannel::ResetChunk(void){
////////////////////////////////////////////////////////////////////////////////////
  chunk_trig_n = 0;
}

////////////////////////////////////////////////////////////////////////////////////
string Ochannel::GetChunkTriggerFile(const unsigned int aChunkTime){
////////////////////////////////////////////////////////////////////////////////////

  // search matching chunk
  for(unsigned int c=0; c<chunk_write.size(); c++){
    if(chunk_write[c]==aChunkTime){
      return chunk_write_tfile[c];
    }
  }

  return "";
}
